<template>
  <label>Cors Origins:</label>
  <lull-datatable
    class="w-full"
    :loading="loading"
    :filter="false"
    :data="origins"
  >
    <lull-datatableColumn id="origin" label="Origin" />
    <lull-datatableColumn :width="'12%'" id="actions" justifyContent="center">
      <span></span>
    </lull-datatableColumn>

    <template v-slot:actions="{ row }">
      <lull-button class="w-0.5" type="danger" @click="remove(row.id)">
        <lull-icon icon="fa-trash" />
      </lull-button>

      <lull-button class="w-0.5 ml-3" type="info" @click="edit(row)">
        <lull-icon icon="fa-edit" />
      </lull-button>
    </template>
  </lull-datatable>

  <div class="w-full mt-2 flex justify-end">
    <lull-button type="info" @click="showModal()">New Cors Origin</lull-button>
  </div>

  <lull-modal v-model="modalVisible" width="50rem" :closableMask="false">
    <corsorigin
      :action="action"
      :origin="selected"
      :clientId="clientId"
      @close="hideModal()"
      @refresh="refresh()"
    />
  </lull-modal>

  <confirm
    v-model="confirmationModal"
    :callback="confirmationCallback"
    message="Are you sure you want to delete this cors origins? This cannot be undone."
  />
</template>

<script lang="ts">
import { ClientCorsOrigin } from '@/core/models/client/ClientCorsOrigin';
import { ManageAction } from '@/core/types/ManageAction';
import { useStore } from '@/store';
import { ClientAction } from '@/store/Clients/ClientModule';
import { computed, ComputedRef, defineComponent, onMounted, ref } from 'vue';
import { Confirm } from '@/core/components';
import CorsOrigin from './CorsOrigin.vue';

export default defineComponent({
  name: 'corsorigins',
  components: {
    corsorigin: CorsOrigin,
    confirm: Confirm,
  },
  props: {
    clientId: { type: String, required: true },
  },
  setup(props) {
    const store = useStore();
    const selected = ref<Partial<ClientCorsOrigin>>();
    const loading: ComputedRef<boolean> = computed(
      () => store.getters['client/corsOriginLoadingState']
    );
    const origins = ref<ClientCorsOrigin[]>([]);
    const modalVisible = ref<boolean>(false);
    const action = ref<ManageAction>(ManageAction.Create);
    const confirmationModal = ref<boolean>(false);
    const confirmationCallback = ref<Function | null>(null);

    function showModal(): void {
      modalVisible.value = true;
    }

    function hideModal(): void {
      selected.value = {
        id: 0,
        origin: '',
      };
      action.value = ManageAction.Create;
      modalVisible.value = false;
    }

    async function getCorsOrigins(): Promise<void> {
      const results = await store.dispatch(
        `client/${ClientAction.GetCorsOrigins}`,
        props.clientId
      );

      if (results) {
        origins.value = results;
      }
    }

    async function refresh(): Promise<void> {
      hideModal();
      await getCorsOrigins();
    }

    function edit(row: ClientCorsOrigin): void {
      action.value = ManageAction.Edit;
      selected.value = row;
      showModal();
    }

    async function remove(id: number): Promise<void> {
      const cb = async (): Promise<void> => {
        const results = await store.dispatch(
          `client/${ClientAction.DeleteCorsOrigin}`,
          id
        );

        if (results) {
          await getCorsOrigins();
        }
      };

      confirmationCallback.value = cb;
      confirmationModal.value = true;
    }

    onMounted(async () => {
      await getCorsOrigins();
    });

    return {
      selected,
      loading,
      modalVisible,
      action,
      showModal,
      hideModal,
      confirmationModal,
      confirmationCallback,
      origins,
      refresh,
      edit,
      remove,
    };
  },
});
</script>

